Use KuechenCurioDB
go 

-- Auf Datenbankebene FileTable aktivieren!



-- Anlegen meiner 1. FileTable
-- Festlegen vom Ordner-Namen unter dem FileStream-Freigabe
-- Festlegen der Sprach-Einstellung 
CREATE TABLE Produktbeschreibung AS FILETABLE
  WITH
  (
    FILETABLE_DIRECTORY = 'Produktbeschreibung',
    FILETABLE_COLLATE_FILENAME = database_default
  )
GO

-- Anlegen meiner 2. FileTable
-- wenn keine weiteren Angaben, dann Standardeinstellung 
CREATE TABLE Hausmitteilungen AS FILETABLE

-- Vorteil gegenber FileStream: Die User knnen wie gewohnt ... 
-- ... ber die den WINDOWS EXPLORER arbeiten. 
-- Ordner erstellen 
-- Dokumente kopieren 


-- Abfragen der Tabelle 
Select * from Produktbeschreibung
-- Beachtet die Performance bei vielen und groen Dateien in dem Ordner. 


-- Die Spalten stream_id, file_Stream, etc. erklren ... 
-- Genial ist: Ich wei ber das 'Creation_Time' jetzt genau, von wann der Katalog ist. 


-- Erstellen eines Ordners durch T-SQL 
	INSERT INTO Produktbeschreibung(name, is_directory) VALUES ( 'Messeneuheiten_2014', 1)

-- Lschen einer Datei 
	Delete Produktbeschreibung WHERE name = '1_Beschreibung_3Besteck.txt'

-- Setzen einer Datei auf schreibgeschtzt 
	UPDATE Produktbeschreibung 
	SET is_readonly = 1 WHERE name = '1_Beschreibung_4Ofen.txt'

-- Einfgen einer Datei
-- File_Type ist nicht notwendig, weil berechnet wird. 
insert into Produktbeschreibung
	(name, file_stream)
values
	( 'Apothekerschrank.txt', 0x) 

Select * from Produktbeschreibung


-- Ausgabe des Pfades im Klartext 
	SELECT name, file_stream.GetFileNamespacePath(0) as Pfad, is_directory FROM Produktbeschreibung
-- Ausgabe des vollstndigen Pfades 
	SELECT name, file_stream.GetFileNamespacePath(1) as Pfad, is_directory FROM Produktbeschreibung
	SELECT  FileTableRootPath() + file_stream.GetFileNamespacePath() as Pfad FROM Produktbeschreibung


-- Anmerkung: Statt T-SQL oder .Net kann ich die ... 
-- ... klassischen DOS-Befehle (XCopy, etc.) zum ... 
-- ... Dateimanagement nutzen. 
